using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Threading.Tasks;
using Ninject;

namespace TourDataManager {
    public class Authenticator : IAuthenticator {
        private readonly Uri authUri = new Uri("https://biganto.com/users/login/?client=desktopplayer&client_version=3.0&v=2.0");

        [Inject] public HttpClient HttpClient{ get; set; }

        public (bool, string) Login(string email, string password){
            return LoginAsync(email, password).Result;
        }

        public async Task<(bool,string)> LoginAsync(string email, string password){
            var x = await HttpClient.PostAsync(authUri,
                new FormUrlEncodedContent(new[]{
                    new KeyValuePair<string, string>("email", email), 
                    new KeyValuePair<string, string>("password", password)
                }));
            var content = await x.Content.ReadAsStringAsync();
            return (x.IsSuccessStatusCode, content);
        }

        public void Logout(){
            throw new NotImplementedException();
        }
    }
}